import 'package:dabric/build/project.dart' as _;
import 'package:objd/build/buildProject.dart';
import 'package:objd/build/io.dart';
import 'package:objd/build/reloader.dart';
import 'package:objd/core.dart';

void build(List<String> args, _.Project project, List<Pack> packs) {
	var stopwatch = new Stopwatch()..start();
	var opts = GenOptions(args);
	var buildProj = BuildProject(Project(
		name: '',
		target: './build',
		generate: project
	), prod: opts.prod);

	// === CUSTOM CODE -> START === \\

	// Disable meta file generation
	buildProj.isGenMeta = false;

	// Add packs to process
	packs.forEach((pack) {
		buildProj.addPack(pack);
	});

	// === CUSTOM CODE -> END === \\

	if(opts.hotreload) {
		reloadProject(buildProj);
	}

	generateIO(buildProj, opts);
	print("Total Generation Time: ${stopwatch.elapsedMilliseconds}ms");
}
