import 'package:dabric/utils/delay.dart';
import 'package:dabric/utils/detect.dart';
import 'package:dabric/utils/stat.dart';
import 'package:objd/basic/condition.dart';
import 'package:objd/basic/entity.dart';
import 'package:objd/basic/score.dart';

class Conds {
	static Condition detect(DetectType type, [Entity entity]) {
		return Detect.when(type, entity);
	}

	static Condition delay(int ticks) {
		return Delay.when(ticks);
	}

	static Condition statLt(String name, int value, [Entity entity]) {
		return Stat.when(name, (Score s) => s.matchesRange(Range(to: value)), entity);
	}

	static Condition statGt(String name, int value, [Entity entity]) {
		return Stat.when(name, (Score s) => s.matchesRange(Range(from: value)), entity);
	}

	static Condition statBtw(String name, int lvalue, int hvalue, [Entity entity]) {
		return Stat.when(name, (Score s) => s.matchesRange(Range(from: lvalue, to: hvalue)), entity);
	}
}
