import 'dart:collection';

import 'package:objd/basic/condition.dart';
import 'package:objd/basic/entity.dart';
import 'package:objd/basic/for_list.dart';
import 'package:objd/basic/score.dart';
import 'package:objd/basic/scoreboard.dart';
import 'package:objd/basic/widget.dart';
import 'package:objd/wrappers/execute.dart';

class Delay {
	static const String _board = 'dabric_delay';
	static final HashMap<int, Score> _scores = HashMap();

	static Widget load() {
		return For.of([
			Scoreboard(_board, addIntoLoad: false),
			..._scores.values.map((v) => v.set(0))
		]);
	}

	static Widget tick() {
		List<Widget> actions = [];

		_scores.forEach((k, v) {
			actions.addAll([
				Execute(If: Condition.score(v.matchesRange(Range(from: k))), children: [v.set(0)]),
				v.add(1)
			]);
		});

		return For.of([
			...actions
		]);
	}

	static Score _addDelay(int ticks) {
		if (!_scores.containsKey(ticks)) {
			_scores[ticks] = Score(Entity.PlayerName('d_${ticks}'), _board, addNew: false);
		}

		return _scores[ticks];
	}

	static Condition when(int ticks) {
		return Condition.score(_addDelay(ticks).matchesRange(Range(from: ticks)));
	}
}
